//------ INCLUDES -------------------

#include <iostream.h>
#include <fstream.h>
#include <strclass.h>
#include <stdlib.h>
#include <time.h>

//------ DEFINES --------------------

#define MAX_T 10000

#define JOUR  0
#define MOIS  1
#define ANNEE 2
#define MINI  3
#define MAXI  4

//------ DECLARATIONS GLOBALES ------

int t[MAX_T][5];
int nb;

//------ ERREUR ---------------------

void erreur(String message)
{

 cout << endl << message << endl;
 exit(1);
}

//------ RANDOMIZE ------------------

void randomize(void)
{

 srand(time(0));
}

//------ ALEA -----------------------

int alea(int mini,int maxi)
{

 return mini + rand() % (maxi-mini+1);
}

//------ DATE_DEJA_EXISTANTE --------

int date_deja_existante(int arret,int j,int m,int a)
{
 int i;

 for(i=0;i<arret;i++)
    if(t[i][JOUR]==j && t[i][MOIS]==j && t[i][ANNEE]==a) return 1;
 return 0;
}

//------ BISSEXTILE -----------------

int bissextile(int a)
{

 return a%400==0 || a%4==0 && a%100!=0;
}

//------ NBJOUR ---------------------

int nbjour(int m,int a)
{
 int n[12]={31,28,31,30,31,30,31,31,30,31,30,31};

 if(m!=2) return n[m-1];
 if(bissextile(a)==1) return 29;
 return 28;
}

//------ GENERER_DATE ---------------

void generer_date(int &j, int &m, int &a)
{

 a=alea(1970,1997);
 m=alea(1,12);
 j=alea(1,nbjour(m,a));
}

//------ GENERER_TABLEAU ------------

void generer_tableau(void)
{
 int i,j,m,a;

 for(i=0;i<nb;i++)
    {
     do {
         generer_date(j,m,a);
        }while(date_deja_existante(i,j,m,a)==1);
     t[i][JOUR]=j;
     t[i][MOIS]=m;
     t[i][ANNEE]=a;
     t[i][MINI]=alea(-20,23);
     do {
         t[i][MAXI]=alea(-10,40);
        }while(t[i][MAXI]<t[i][MINI]);
    }
}

//------ MAIN -----------------------

void main(void)
{
 int i,j;
 fstream fichier;

 randomize();
 cout << "Nombre de relevs  crer ? ";
 cin  >> nb;
 if(nb<1 || nb>10000) erreur("Nombre incorrect");
 generer_tableau();
 fichier.open("meteo.dat",ios::out);
 if(fichier.bad()) erreur("Impossible de crer le fichier meteo.at");
 for(i=0;i<nb;i++)
    {
     for(j=0;j<5;j++) fichier << t[i][j] << " ";
     fichier << endl;
    }
 fichier.close();
}
